﻿# Как создать автовидеоинструкцию

## Какой надо установить софт

1. VLC - только версию 2.1.5 по [ссылке](https://www.videolan.org/vlc/releases/2.1.5.html).
  
    * **Версию 2.2 или выше не ставить, будут ошибки.**

2. Пакет ImageMagick. [Ссылка](http://www.imagemagick.org/script/download.php) 

    * Выбирать пакет, в котором есть "dll", например "ImageMagick-7.0.7-22-Q16-x64-dll.exe".
    * Необходимо прописать путь в Path. 
    * Также при установке ImageMagick необходимо обязательно установить флаг `Install legacy utilities (e.g. convert)` , иначе `convert.exe` не будет установлен.
3. Oscript. [Ссылка](http://oscript.io/downloads) 

    * Необходимо прописать путь в Path.

4. (Не обязательно) Для озвучки голосом необходимо установить [Microsoft Speech Platform х32](https://www.microsoft.com/en-us/download/details.aspx?id=27225) и [Server Runtime Languages](https://www.microsoft.com/en-us/download/details.aspx?id=27224), `MSSpeech_TTS_ru-RU_Elena` или другую голосовую библиотеку.

    * Если не хотите озвучивать текст - надо **снять** флаг **Делать озвучку TTS**.

5. (Не обязательно) Также понадобится голосовой движок Балаболка консольный вариант. [Ссылка](http://www.cross-plus-a.ru/bconsole.html) 
    
    * Необходимо прописать путь в Path.

6. Если на компьютере нет аудио-карты (настоящей или виртуальной) - озвучка работать не будет из-за особенностей движка TTS.
7. (Не обязательно) Для отрисовки рамки вокруг активного элемента формы и для перемещения курсора мыши надо скачать UItoolsFor1C.zip [отсюда](https://github.com/Pr-Mex/UItoolsFor1C/releases) и распаковать архив в каталог add\tools\VideoTools.

    * Если не хотите использовать эти утилиты - тогда надо **снять** флаги **Подсвечивать активные элементы формы** и **Перемещать курсор мышки к активному элементу формы**.
8. Перезагрузиться.
9. Заполнить поля, необходимые для записи видео. 

    * Рекомендуется сначала заполнить настройки по умолчанию 
        * на закладке **Автоинструкции** кнопка **Загрузить настройки по умолчанию**.

10. Затем на закладке **Автоинструкции** нажать на кнопку **Проверить что запись видео будет работать** и убедиться в прохождении всех проверок.

## Настройки записи

Что означают параметры записи.
Чтобы не ломать себе голову какими должны быть настройки - нажмите на кнопку **ЗагрузитьНастройкиПоУмолчанию**. Многие параметры сразу заполнятся как надо.
Скорее всего, надо будет изменить путь к команде `Convert` и каталогу музыки.

1. **Флаг Создавать видеоинструкцию** - если Истина - тогда будет создаваться видео.
2. **Каталог для формирования инструкций Видео** - туда будет выложен результат записи видео - **result.mp4**
3. **Экран ширина** - понятно. Если указать больше чем есть в реальности - то при вызове VLC значение будет приведено к реальному.
4. **Экран высота** - понятно. Если указать больше чем есть в реальности - то при вызове VLC значение будет приведено к реальному.
5. **Количество кадров в секунду** - минимум 5, я ставлю 10. Чем больше кадров тем больше нагружается процессор.
6. **Команда начать запись видео** - вызов VLC для старта записи видео. Да, VLC умеет записывать видео и он управляется по tcp с (помощью OneScript). Поэтому используется именно он.
7. **Файл курсор мыши** - чтобы на экране было записано движение мыши - надо указать файл в формате png с изображением курсора.
8. **Каталог для временных файлов** - просто каталог где будут формироваться временные файлы. Не должен совпадать с **Каталог для формирования инструкций Видео**. Каталог для временных файлов нужен чтобы потом разобраться что пошло не так, если в видео есть артефакты.
9. **Файл водяной знак** - иконка в формате png, которая появится в правом нижнем углу видео. Если параметр пустой - то лого указываться не будет.
10. **Команда ffmpeg** - как будет вызываться ffmpeg.
11. **Команда Convert** - как будет вызываться Convert из пакета ImageMagic. Необходимо указывать полный путь к exe, т.к. в windows есть своя команда convert. В этом можно убедиться с помощью поиска.
12. **Каталог музыки** - каталог с mp3, которые могут быть взяты в качестве музыкальной подложки. Если параметр пустой - то музыки в видео не будет. Если mp3 в каталоге несколько - то будет выбран случайный трек. Если длительность mp3 меньше длительности видео - тогда трек будет автоматически продлен столько раз, сколько необходимо.
13. **Подсвечивать активные элементы форм** - при изменении элемента формы около него будет рисоваться красная рамка.
14. **Перемещать курсор мышки к активному элементу формы** - при изменении элемента формы к нему будет перемещаться курсор мышки.
15. **Делать озвучку TTS** - флаг того что надо использовать технологию text to speech. Шаги в видео будут озвучены голосом.
16. **Путь к движку TTS** - команда вызова движка, который преобразует текст в wav.
17. **Имя голоса TTS** - часть строки с именем голоса. Например **Elena**. Таким образом можно указать какой голос использовать для озвучки если их много.
18. **Путь к словарю замен** - словарь замен слов или части слов для коррекции произношения. Смотрите пример из Vanessa-ADD.

## **Основные принципы:**

1. Каждый шаг в видеоинструкции будет озвучен и к нему будут добавлены субтитры.

2. Каждый шаг видео может масштабироваться по времени (т.е. стать длиннее или короче). Это нужно, чтобы синхронизировать видеоряд и озвучку.

3. Чтобы сделать видео вставку в произвольном месте нужно использовать шаг

   ​

   ```
   И обратите внимание "Текст видеовставки."
   ```

4. Все группы шагов будут автоматически преобразованы в видеовставку (белый текст на черном фоне). Вот пример:



   ![](./doc/images/MakeAutoVideo.png)



5. Есть специальные управляющие конструкции, которые надо указывать в тексте сценария перед нужным шагом или группой.

   **1)  Произвольный текст шага - autodoc.text**.

   Пусть в сценарии есть шаг:

   ```
   Когда В командном интерфейсе я выбираю "Основная" "Справочник1"
   ```

   Тогда если перед ним (т.е. строкой выше) написать:

   ```
   #[autodoc.text] В интерфейсе \[я\] выбираю %2 и %1 ["" + ТекущаяДата()]
   ```

   тогда при формировании инструкции текст шага будет таким:

   ```
   В интерфейсе [я] выбираю "Справочник1" и "Основная" 08.04.1981 01:00
   ```

   Т.е. *%2* и *%1* были заменены на параметры шага. Выражение *["" + ТекущаяДата()]* было вычислено через метод *Вычислить()*.

   А текст *\[я\]* содержал в себе экранирование квадратных скобок.

   **2) Не включать шаг в инструкцию - autodoc.ignorestep** 

   Если перед шагом или группой шагов написать *#[autodoc.ignorestep]*, тогда он/они будет выполнен, но не попадёт в финальный видео файл.

   **3) Отключить автомасштабирование шага или группы.** *autodoc.donotscale* 

   Если перед шагом или группой написать *#[autodoc.donotscale],* тогда он не будет сжиматься по времени для синхронизации голоса и видео.

   **4) Сделать из группы шагов один шаг - autodoc.groupsteps**

   Пусть в сценарии есть группа шагов с текстом:

   ```
   Просто группа шагов
   ```

   Если перед ней написать

   ```
   #[autodoc.groupsteps] В интерфейсе я выбираю Справочник1 и Справочник2 ["" + 11 + 22] тогда
   ```

   а) Вся группа шагов будет восприниматься как один шаг.

   б) Специальная видеовставка для группы создаваться не будет.

   в) В финальном видео эта группа станет одним шагом с текстом

   ```
   В интерфейсе я выбираю Справочник1 и Справочник2 1122
   ```

   г) Если после директивы *#[autodoc.groupsteps]*  не указан текст, тогда будет использовано текущее имя группы.

   **5) Исключить слайд сценария - autodoc.ignore.scenarioslide**

    Для исключения слайда сценария с текстом

   ```
   Сценарий.<Текст сценария>
   ```

    надо перед строкой, где объявляется сценарий написать

   ```
   #[autodoc.ignore.scenarioslide]
   ```

   **6) Исключить слайд с заголовком фичи - autodoc.ignore.featureslide**

   Для исключения слайда с заголовком фича файла надо перед строкой, где объявляется имя функциональности написать

   ```
   #[autodoc.ignore.featureslide]
   ```

   **7) Исключить финальный слайд, где указана данные по сборке сценария - autodoc.ignore.finalslide**

   Для исключения слайда с заголовком фича файла надо перед строкой, где объявляется имя функциональности написать

   ```
   #[autodoc.ignore.finalslide]
   ```
