# Подсистема TDD-XDD из Vanessa-ADD - простой и мощный фреймворк для тестирования кодом в 1С

**Миссия продукта - повышение качества разработки.**

Продукт позволяет проверять различные поведение систем на базе 1С и проверяет/гарантирует качество функциональности системы и ее составных частей.

Подсистема TDD-XDD работает с любыми конфигурациями, полностью независима от кода конфигурации.

Позволяет открывать/тестировать в разных режимах - обычное приложение, тонкий и толстый клиент управляемого приложения. Поддерживаются любые платформы 1С - от 8.2.17 до 8.3.5 и выше.

Для быстрого входа рекомендуем [почитать статьи или посмотреть видео](Статьи-и-видео-по-тестированию-в-1С.MD)

Тесты могут быть как во внешних обработках, так и во встроенных обработках.

Возможно очень простое создание тестовых данных на основании табличных макетов. Эти макеты можно генерировать из реальных боевых данных. Полученные данные в тестах загружаются одной строкой кода. Посмотрите [Генерацию данных](Генерация-данных.MD)

Любые наборы тестов могут прогоняться в полностью автоматическом режиме через [специальную командную строку запуска](Запуск-тестов-из-командной-строки-и-получение-файлов-результатов.MD). Автозапуск используется в различных build-серверах и в системах Continuous Integration.

В случае возникновения каких-либо проблем при тестировании рекомендуем заглянуть на страницу [Известные проблемы при тестировании](Известные-проблемы-при-тестировании.MD)

## Использование

* [Формат тестов](Создание-файлов-тестов.MD)

  * [Сценарные тесты - сценарии в виде связанных и последовательных шагов](Сценарные-тесты---сценарии-в-виде-связанных-и-последовательных-шагов.MD)

* [Принципы написания тестов](Принципы-написания-тестов.MD)

* [Тестирование через образец исходных данных](Тестирование-через-образец-исходных-данных.MD)

* [Методы проверки/утверждений](Методы-проверки---утверждения.MD)
  * [Базовые утверждения](Базовые-утверждения.MD) - простые, но мощные утверждения.
  * [Текучие (fluent) утверждения](Текучие-(fluent)-утверждения.MD) - очень красивые и довольно удобные. Можно выполнять несколько проверок в одной строке проверки.
  * [Проверка таблиц и табличных документов](Проверка-таблиц-и-табличных-документов.MD)

* [Система плагинов](Система-плагинов.MD)
  * [Генерация данных](Генерация-данных.MD)
  * [ВременныеФайлы](ВременныеФайлы.MD)
  * [КомандныйФайл](КомандеыйФайл.MD)
  * [ПарсерКоманднойСтроки](ПарсерКоманднойСтроки.MD)
  * [ЗапросыИзБД](ЗапросыИзБД.MD)
  * [ЗагрузчикПользовательскихНастроек](Загрузчик-пользовательских-настроек.MD)

* [Дымовые тесты (тесты открытия всех форм)](../../tests/smoke)

* [Известные проблемы при тестировании](Известные-проблемы-при-тестировании.MD)

[Запуск тестов из командной строки и получение файлов результатов](Запуск-тестов-из-командной-строки-и-получение-файлов-результатов.MD)

* [Запуск тестов на build-серверах Jenkins, TeamCity и т.д.](Запуск-тестов-из-командной-строки-и-получение-файлов-результатов.MD#запуск-тестов-на-build-серверах)

Примеры тестов:

* [Пример теста СКД и отчета, сделанного на компоновке](Пример-теста-СКД-и-отчета,-сделанного-на-компоновке.MD)
