# Загрузчик пользовательских настроек

## Загрузка глобальных переменных из внешнего файла

Чтобы не зашивать в тесты все плавающие пользовательские переменные, такие как имена баз, строки подключения, логины, пароли и др., имеется возможность забирать эти переменные из внешнего файла или внешнего key-value хранилища по http протоколу (поддерживается `Consul`). Это может быть особенно полезно, когда над фичами работает команда, и у каждого участника существуют свои настройки подключения к базам.

Чтобы воспользоваться этой функциональностью для файлового режима, нужно выполнить следующее:

1. В своем каталоге проекта создать файл `user_settings.json` следующего формата:

```json
{
  "userSettings": [
      {
        "user": "USERNAME_1",
        "settings": {
            "ИМЯ_ПЕРЕМЕННОЙ_1": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_1",
            "ИМЯ_ПЕРЕМЕННОЙ_2": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_2",
        }
      },
      {
        "user": "USERNAME_2",
        "settings": {
            "ИМЯ_ПЕРЕМЕННОЙ_1": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_1",
            "ИМЯ_ПЕРЕМЕННОЙ_2": "ЗНАЧЕНИЕ_ПЕРЕМЕННОЙ_2",
        }
      }
  ]
}
```

2. В свойства user поставить доменное (локальное) имя пользователя, для которого должны применяться настройки. Именно по этому свойству будет определяться, какие пользовательские настройки нужно загружать.

3. В свойстве settings прописать конкретные настройки для каждого пользователя. Состав настроек необязательно должен совпадать между пользователями, для какого-то пользователя настройки могут отсутствовать.

4. Открыть обработку `bddRunner` из корня `Vanessa.ADD` - файл `user_settings.json` подтянется автоматически из каталога, в котором находится `Vanessa.ADD` (поле `Каталог инструментов` на вкладке `Сервис`). Если такого файла нет, то загрузка не выполняется. Имеется возможность указать свой каталог загрузки настроек, он подчиняется свойству `Каталог проекта` на вкладке `Сервис`.

Если файл найден, то на основании текущего имени пользователя компьютера или домена (которое определяется через WShell скрипт), ищутся настройки текущего пользователя и загружаются только они. Если настройки не найдены, то выводится предупреждающее сообщение.

Чтобы воспользоваться этой функциональностью для `Consul`-a нужно: 

1. Развернуть единый сервер консула и установить агентов консула на каждой машине, на которой запускается `Vanessa.ADD`. 
2. На вкладке `Сервис` в `Vanessa.ADD` указать `Поставщик пользовательских настроек` равным `CONSUL`, а в поле `Адрес пользовательских настроек` указать полный url к настройкам на сервере. Url должен содержать путь, доступный через REST интерфейс консула, например http://127.0.0.1:8500/v1/kv/ivanov




