<a id="markdown-запуск-тестов-из-командной-строки-и-получение-результатов" name="запуск-тестов-из-командной-строки-и-получение-результатов"></a>
# Запуск тестов из командной строки и получение результатов

<!-- TOC -->

- [Запуск тестов из командной строки и получение результатов](#запуск-тестов-из-командной-строки-и-получение-результатов)
    - [Пример командной строки запуска тестов](#пример-командной-строки-запуска-тестов)
    - [Параметры запуска](#параметры-запуска)
    - [Показ отчета в формате Yandex Allure](#показ-отчета-в-формате-yandex-allure)
    - [Запуск тестов на build-серверах](#запуск-тестов-на-build-серверах)

<!-- /TOC -->

<a id="markdown-пример-командной-строки-запуска-тестов" name="пример-командной-строки-запуска-тестов"></a>
## Пример командной строки запуска тестов

```cmd
"C:\Program Files\1cv82\8.2.19.102\bin\1cv8.exe" ENTERPRISE /F"D:\ibService" 
/Nadmin /P1 /RunModeManagedApplication /Execute "D:\xUnitFor1C\xddTestRunner.epf"
/C "xddRun ЗагрузчикКаталога ""D:\Tests"";
xddReport ГенераторОтчетаJUnitXML ""D:\testReport\report.xml"";
xddShutdown;"
```

или для получения отчета в формате Yandex Allure ( см. [ниже](#Показ-отчета-в-формате-Yandex-Allure))

```cmd
"C:\Program Files\1cv82\8.2.19.102\bin\1cv8.exe" ENTERPRISE /F"D:\ibService" 
/Nadmin /P1 /RunModeManagedApplication /Execute "D:\xUnitFor1C\xddTestRunner.epf"
/C "xddRun ЗагрузчикКаталога ""D:\Tests"";
xddReport ГенераторОтчетаAllureXML ""D:\testReport\report-allure.xml"";
xddShutdown;"
```

Параметры отделяются друг от друга символом `;`

<a id="markdown-параметры-запуска" name="параметры-запуска"></a>
## Параметры запуска

1. `xddRun` *обязательно* - команда на загрузку и немедленное выполнение тестов. Следующими параметрами должен идти идентификатор загрузчика тестов и путь тестов для загрузчика. Идентификатор может быть нескольких видов:
   * `ЗагрузчикКаталога` - запуск всех тестов из каталога и вложенных каталогов.
     * в качестве параметра принимает путь каталога
   * `ЗагрузчикФайла` - запуск одного файла внешней обработки-теста
     * в качестве параметра принимает путь файла
   * `ЗагрузчикИзПодсистемКонфигурации` - запуск всех встроенных тестов из встроенной подсистемы или из одной встроенной обработки 
     * например, `Метаданные.Подсистемы.Тестовая` или `Метаданные.Подсистемы.Тестовая.Подсистемы.Подсистема1`
     * например, `Метаданные.Обработки.Тест`
1. `xddReportPath` *обязательно* - указывается путь к файлу отчета тестирования. 
1. `xddShutdown` *рекомендуемый параметр при наличии команды `xddRun`* - завершать работу 1С после прогона тестов

<a id="markdown-показ-отчета-в-формате-yandex-allure" name="показ-отчета-в-формате-yandex-allure"></a>
## Показ отчета в формате Yandex Allure

За показа отчет в этом формате отвечает плагин "ГенераторОтчетаAllureXML"

Пример запуска тестирования с получением такого отчета:

```cmd
"C:\Program Files\1cv82\8.2.19.102\bin\1cv8.exe" ENTERPRISE /F"D:\ibService" 
/Nadmin /P1 /RunModeManagedApplication /Execute "D:\xUnitFor1C\xddTestRunner.epf"
/C "xddRun ЗагрузчикКаталога ""D:\Tests"";
xddReport ГенераторОтчетаAllureXML ""C:\reports\report-allure.xml"";
xddShutdown;"
```

Для получения отчета нужно выполнить следующую последовательность действий:

1. Запуск через командную строку в пакетном режиме. Пример указан выше
1. Запуск тестирования через указанную командную строку
1. Выполнение команды по очереди (allure уже должен быть прописан в PATH):

- при условии генерации отчета в каталог `C:\myproject\allure`

```cmd
cd /d C:\reports
allure generate --clean allure
allure open
```

<a id="markdown-запуск-тестов-на-build-серверах" name="запуск-тестов-на-build-серверах"></a>
## Запуск тестов на build-серверах

Позволяет выгружать результаты тестов в формате junit

Для запуска из TeamCity можно использовать следующую команду

```cmd
chcp 1251

"C:\Program Files (x86)\1cv8\8.3.7.1845\bin\1cv8.exe" /DisableStartupMessages 
/Execute "%teamcity.build.checkoutDir%\xddTestRunner.epf" /F "tempdb" /N "Admin" /P1 
/C "xddRun ЗагрузчикКаталога ""%teamcity.build.checkoutDir%\Tests"";
xddReport ГенераторОтчетаJUnitXML ""%teamcity.build.checkoutDir%\report_ordinary.xml"";
xddShutdown;"
```

Готовый файл шаблона для TeamCity [XUnitFor1C_v4_TeamCity](https://github.com/xDrivenDevelopment/xUnitFor1C/releases/download/4.0.0.4/XUnitFor1C_v4_TeamCity.zip)

Для запуска из jenkins можно использовать следующую команду

```cmd
chcp 1251

"C:\Program Files (x86)\1cv8\8.3.7.1845\bin\1cv8.exe" ENTERPRISE /F"%WORKSPACE%\testib" 
/DisableStartupMessages 
/Execute "%WORKSPACE%\xddTestRunner.epf" /N "Admin" /P1 
/C "xddRun ЗагрузчикКаталога ""%WORKSPACE%\Tests"";
xddReport ГенераторОтчетаJUnitXML ""%WORKSPACE%\report_ordinary.xml"";xddShutdown;"
```
