# Fake SMTP Server
Набор методов для работы с Fake-SMTP-Server

Используется для тестирования отправки почты. Необходимо поставить пакет [fake-smtp-server](https://www.npmjs.com/package/fake-smtp-server)

## Реализовано

* Работа с настройками ящика
* Очистка ящика
* Проверка почты
* Проверка новой почты
* Фильтрация почты по
  
  + Теме
  + Тексту
  + Получателю
  + Отправителю

## Примеры сценариев

```
    Допустим отправляю уведомления на почту
    Тогда пришло письмо
        Тогда в ящике есть новые письма
        И письма для "user@fakemail.com"
        И темой письма "SPAM!!!"
```

```
    Допустим подготовим ящик
        Допустим порт ящика 777
        И адрес ящика 192.168.1.1
        И очищаем ящик
    И отправим пачку писем
    Тогда в ящике есть письма
```

## Две группы шагов

### Получение списка писем из ящика

Эти методы получают данные непосредственно из ящика. Данные сохранены в переменную Контекст

```
Тогда в ящике есть письма с темой "Тема"
Тогда в ящике есть письма с текстом "Текст"
Тогда в ящике есть письма от "Отправитель"
Тогда в ящике есть письма для "Получатель"
```

### Уточнение параметров писем

Эти методы берут пиьсма из переменной Контекст и уточняют значение полей

```
И темой письма "Тема"
И текстом письма "Текст"
И письма от "Отправитель"
И письма для "Получатель"
```

# ИнтернетПочта
Набор методов для работы с GreenMail

Используется для тестирования отправки и получения электронной почты.
Необходимо поставить сервер [Greenmail](http://www.icegreen.com/greenmail/)

## Отличия от Fake-SMTP-Server:
* поддержка IMAP - можно более тщательно протестировать алогритмы отправки и получения электронных писем
* для предотвращения конфликтов с FakeSMTPServer в шагах вместо слова "письма" используется термин "сообщения"
